'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var handleKeypress = function () {
  var _ref2 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(key) {
    var _this = this;

    var _ref3, success, error, localAddress, _ref4, _success, msg, lanAddress, defaultRecipient, rl, _handleKeypress, _cleanup, _cancel, reset;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.t0 = key;
            _context3.next = _context3.t0 === CTRL_C ? 3 : _context3.t0 === CTRL_D ? 3 : _context3.t0 === 'a' ? 5 : _context3.t0 === 'i' ? 15 : _context3.t0 === 's' ? 28 : _context3.t0 === 'q' ? 44 : _context3.t0 === 'r' ? 48 : _context3.t0 === 'R' ? 48 : _context3.t0 === 'd' ? 54 : 61;
            break;

          case 3:
            process.emit('SIGINT');
            return _context3.abrupt('return');

          case 5:
            clearConsole();
            (0, (_log || _load_log()).default)('Starting Android...');
            _context3.next = 9;
            return (_xdl || _load_xdl()).Android.openProjectAsync(process.cwd());

          case 9:
            _ref3 = _context3.sent;
            success = _ref3.success;
            error = _ref3.error;

            if (!success) {
              (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.red(error.message));
            }
            printUsage();
            return _context3.abrupt('return');

          case 15:
            clearConsole();
            (0, (_log || _load_log()).default)('Starting iOS...');
            _context3.next = 19;
            return (_xdl || _load_xdl()).UrlUtils.constructManifestUrlAsync(process.cwd(), {
              hostType: 'localhost'
            });

          case 19:
            localAddress = _context3.sent;
            _context3.next = 22;
            return (_xdl || _load_xdl()).Simulator.openUrlInSimulatorSafeAsync(localAddress);

          case 22:
            _ref4 = _context3.sent;
            _success = _ref4.success;
            msg = _ref4.msg;

            if (!_success) {
              (_log || _load_log()).default.error(msg);
            }
            printUsage();
            return _context3.abrupt('return');

          case 28:
            stopWaitingForCommand();
            _context3.next = 31;
            return (_xdl || _load_xdl()).UrlUtils.constructManifestUrlAsync(process.cwd(), {
              hostType: 'lan'
            });

          case 31:
            lanAddress = _context3.sent;
            _context3.next = 34;
            return (_xdl || _load_xdl()).UserSettings.getAsync('sendTo', null);

          case 34:
            defaultRecipient = _context3.sent;
            rl = readline.createInterface({
              input: process.stdin,
              output: process.stdout
            });

            _handleKeypress = function _handleKeypress(chr, key) {
              if (key && key.name === 'escape') {
                _cleanup();
                _cancel();
              }
            };

            _cleanup = function _cleanup() {
              rl.close();
              process.stdin.removeListener('keypress', _handleKeypress);
              startWaitingForCommand();
            };

            _cancel = function _cancel() {
              clearConsole();
              printUsage();
            };

            clearConsole();
            process.stdin.addListener('keypress', _handleKeypress);
            (0, (_log || _load_log()).default)('Please enter your phone number or email address (press ESC to cancel) ');
            rl.question(defaultRecipient ? '[default: ' + defaultRecipient + ']> ' : '> ', function () {
              var _ref5 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(sendTo) {
                var sent;
                return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _cleanup();
                        if (!sendTo && defaultRecipient) {
                          sendTo = defaultRecipient;
                        }
                        sendTo = sendTo && sendTo.trim();

                        if (sendTo) {
                          _context2.next = 6;
                          break;
                        }

                        _cancel();
                        return _context2.abrupt('return');

                      case 6:
                        (_log || _load_log()).default.withTimestamp('Sending ' + lanAddress + ' to ' + sendTo + '...');

                        sent = false;
                        _context2.prev = 8;
                        _context2.next = 11;
                        return Exp.sendAsync(sendTo, lanAddress, true);

                      case 11:
                        (_log || _load_log()).default.withTimestamp('Sent link successfully.');
                        sent = true;
                        _context2.next = 18;
                        break;

                      case 15:
                        _context2.prev = 15;
                        _context2.t0 = _context2['catch'](8);

                        (_log || _load_log()).default.withTimestamp('Could not send link. ' + _context2.t0);

                      case 18:
                        printUsage();

                        if (!sent) {
                          _context2.next = 22;
                          break;
                        }

                        _context2.next = 22;
                        return (_xdl || _load_xdl()).UserSettings.setAsync('sendTo', sendTo);

                      case 22:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this, [[8, 15]]);
              }));

              return function (_x3) {
                return _ref5.apply(this, arguments);
              };
            }());
            return _context3.abrupt('return');

          case 44:
            clearConsole();
            _context3.next = 47;
            return printServerInfo();

          case 47:
            return _context3.abrupt('return');

          case 48:
            clearConsole();
            reset = key === 'R';

            if (reset) {
              (_log || _load_log()).default.withTimestamp('Asking packager to reset its cache...');
            }
            (_log || _load_log()).default.withTimestamp('Restarting packager...');
            (_xdl || _load_xdl()).Project.startAsync(process.cwd(), { reset: reset });
            return _context3.abrupt('return');

          case 54:
            clearConsole();
            dev = !dev;
            _context3.next = 58;
            return (_xdl || _load_xdl()).ProjectSettings.setAsync(process.cwd(), { dev: dev });

          case 58:
            (0, (_log || _load_log()).default)('Packager now running in ' + (_chalk || _load_chalk()).default.bold(dev ? 'development' : 'production') + (_chalk || _load_chalk()).default.reset(' mode.') + '\nPlease close and reopen the project in the Expo app for the\nchange to take effect.');
            printUsage();
            return _context3.abrupt('return');

          case 61:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function handleKeypress(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var printServerInfo = function () {
  var _ref6 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4() {
    var settings, address, emulatorHelp;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (_xdl || _load_xdl()).ProjectSettings.readPackagerInfoAsync(process.cwd());

          case 2:
            settings = _context4.sent;
            _context4.next = 5;
            return (_xdl || _load_xdl()).UrlUtils.constructManifestUrlAsync(process.cwd());

          case 5:
            address = _context4.sent;
            emulatorHelp = void 0;

            if (process.platform === 'darwin') {
              emulatorHelp = 'Press ' + (_chalk || _load_chalk()).default.bold('a') + ' (Android) or ' + (_chalk || _load_chalk()).default.bold('i') + ' (iOS) to start an emulator.';
            } else {
              emulatorHelp = 'Press ' + (_chalk || _load_chalk()).default.bold('a') + ' to start an Android emulator.';
            }
            (_log || _load_log()).default.nested((_chalk || _load_chalk()).default.bold('View your app with live reloading:') + '\n  ' + (_chalk || _load_chalk()).default.underline('Android device:') + '\n    -> Point the Expo app to the QR code above.\n       (You\'ll find the QR scanner on the Projects tab of the app.)\n  ' + (_chalk || _load_chalk()).default.underline('iOS device:') + '\n    -> Press ' + (_chalk || _load_chalk()).default.bold('s') + ' to email/text the app URL to your phone.\n  ' + (_chalk || _load_chalk()).default.underline('Emulator:') + '\n    -> ' + emulatorHelp + '\nYour phone will need to be on the same local network as this computer.\nFor links to install the Expo app, please visit ' + (_chalk || _load_chalk()).default.underline((_chalk || _load_chalk()).default.cyan('https://expo.io')) + '.\nLogs from serving your app will appear here. Press Ctrl+C at any time to stop.');
            printUsage();

          case 10:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function printServerInfo() {
    return _ref6.apply(this, arguments);
  };
}();

var printRunInstructionsAsync = function () {
  var _ref7 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5() {
    var user;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return (_xdl || _load_xdl()).User.getCurrentUserAsync();

          case 2:
            user = _context5.sent;


            // If no user, we are offline and can't connect
            if (user) {
              (_log || _load_log()).default.newLine();
              (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.bold('Instructions to open this project on a physical device'));
              (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.underline('Android devices') + ': scan the above QR code.');
              (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.underline('iOS devices') + ': run ' + (_chalk || _load_chalk()).default.bold('exp send -s <your-phone-number-or-email>') + ' in this project directory in another terminal window to send the URL to your device.');

              (0, (_log || _load_log()).default)('Alternatively, sign in to your account (' + (_chalk || _load_chalk()).default.bold(user.username) + ') in the latest version of the Expo client on your iOS or Android device. Your projects will automatically appear in the "Projects" tab.');
            }

            (_log || _load_log()).default.newLine();
            (0, (_log || _load_log()).default)((_chalk || _load_chalk()).default.bold('Instructions to open this project on a simulator'));
            (0, (_log || _load_log()).default)('If you already have the simulator installed, run ' + (_chalk || _load_chalk()).default.bold('exp ios') + ' or ' + (_chalk || _load_chalk()).default.bold('exp android') + ' in this project directory in another terminal window.');
            (_log || _load_log()).default.newLine();

          case 8:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function printRunInstructionsAsync() {
    return _ref7.apply(this, arguments);
  };
}();

var _xdl;

function _load_xdl() {
  return _xdl = require('xdl');
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _urlOpts;

function _load_urlOpts() {
  return _urlOpts = _interopRequireDefault(require('./urlOpts'));
}

var _log;

function _load_log() {
  return _log = _interopRequireDefault(require('./log'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dev = void 0;

exports.default = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(projectDir) {
    var _process, stdin;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _process = process, stdin = _process.stdin;

            stdin.setRawMode(true);
            stdin.resume();
            stdin.setEncoding('utf8');
            stdin.on('data', handleKeypress);
            _context.next = 7;
            return (_xdl || _load_xdl()).ProjectSettings.readAsync(projectDir);

          case 7:
            dev = _context.sent.dev;
            _context.next = 10;
            return printServerInfo();

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function startTerminalUI(_x) {
    return _ref.apply(this, arguments);
  }

  return startTerminalUI;
}();

function printUsage() {
  var dim = (_chalk || _load_chalk()).default.dim,
      bold = (_chalk || _load_chalk()).default.bold;

  var devMode = dev ? 'development' : 'production';
  var iosInfo = process.platform === 'darwin' ? dim(', or') + ' i ' + dim('to open iOS emulator.') : dim('.');
  (0, (_log || _load_log()).default)('\n ' + dim('\u203A Press') + ' a ' + dim('to open Android device or emulator') + iosInfo + '\n ' + dim('\u203A Press') + ' s ' + dim('to send the app URL to your phone number or email address') + '\n ' + dim('\u203A Press') + ' q ' + dim('to display QR code.') + '\n ' + dim('\u203A Press') + ' r ' + dim('to restart packager, or') + ' R ' + dim('to restart packager and clear cache.') + '\n ' + dim('\u203A Press') + ' d ' + dim('to toggle development mode. (current mode: ' + bold(devMode) + (_chalk || _load_chalk()).default.reset.dim(')')) + '\n');
}

var CTRL_C = '\x03';
var CTRL_D = '\x04';

var _process2 = process,
    stdin = _process2.stdin;

function startWaitingForCommand() {
  stdin.setRawMode(true);
  stdin.resume();
  stdin.setEncoding('utf8');
  stdin.on('data', handleKeypress);
}

function stopWaitingForCommand() {
  stdin.removeListener('data', handleKeypress);
  stdin.setRawMode(false);
  stdin.resume();
}
module.exports = exports['default'];
//# sourceMappingURL=__sourcemaps__/startTerminalUI.js.map
